   This file documents the the GNU Wget utility for downloading network
data.

   Copyright (C) 1996, 1997, 1998, 2000, 2001 Free Software Foundation,
Inc.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.1 or
any later version published by the Free Software Foundation; with the
Invariant Sections being "GNU General Public License" and "GNU Free
Documentation License", with no Front-Cover Texts, and with no
Back-Cover Texts.  A copy of the license is included in the section
entitled "GNU Free Documentation License".

Recursive Retrieval
*******************

   GNU Wget is capable of traversing parts of the Web (or a single HTTP
or FTP server), following links and directory structure.  We refer to
this as to "recursive retrieving", or "recursion".

   With HTTP URLs, Wget retrieves and parses the HTML from the given
URL, documents, retrieving the files the HTML document was referring
to, through markups like `href', or `src'.  If the freshly downloaded
file is also of type `text/html', it will be parsed and followed
further.

   Recursive retrieval of HTTP and HTML content is "breadth-first".
This means that Wget first downloads the requested HTML document, then
the documents linked from that document, then the documents linked by
them, and so on.  In other words, Wget first downloads the documents at
depth 1, then those at depth 2, and so on until the specified maximum
depth.

   The maximum "depth" to which the retrieval may descend is specified
with the `-l' option.  The default maximum depth is five layers.

   When retrieving an FTP URL recursively, Wget will retrieve all the
data from the given directory tree (including the subdirectories up to
the specified depth) on the remote server, creating its mirror image
locally.  FTP retrieval is also limited by the `depth' parameter.
Unlike HTTP recursion, FTP recursion is performed depth-first.

   By default, Wget will create a local directory tree, corresponding to
the one found on the remote server.

   Recursive retrieving can find a number of applications, the most
important of which is mirroring.  It is also useful for WWW
presentations, and any other opportunities where slow network
connections should be bypassed by storing the files locally.

   You should be warned that recursive downloads can overload the remote
servers.  Because of that, many administrators frown upon them and may
ban access from your site if they detect very fast downloads of big
amounts of content.  When downloading from Internet servers, consider
using the `-w' option to introduce a delay between accesses to the
server.  The download will take a while longer, but the server
administrator will not be alarmed by your rudeness.

   Of course, recursive download may cause problems on your machine.  If
left to run unchecked, it can easily fill up the disk.  If downloading
from local network, it can also take bandwidth on the system, as well as
consume memory and CPU.

   Try to specify the criteria that match the kind of download you are
trying to achieve.  If you want to download only one page, use
`--page-requisites' without any additional recursion.  If you want to
download things under one directory, use `-np' to avoid downloading
things from other directories.  If you want to download all the files
from one directory, use `-l 1' to make sure the recursion depth never
exceeds one.  See Following Links, for more information about this.

   Recursive retrieval should be used with care.  Don't say you were not
warned.

Following Links
***************

   When retrieving recursively, one does not wish to retrieve loads of
unnecessary data.  Most of the time the users bear in mind exactly what
they want to download, and want Wget to follow only specific links.

   For example, if you wish to download the music archive from
`fly.srk.fer.hr', you will not want to download all the home pages that
happen to be referenced by an obscure part of the archive.

   Wget possesses several mechanisms that allows you to fine-tune which
links it will follow.

Spanning Hosts
==============

   Wget's recursive retrieval normally refuses to visit hosts different
than the one you specified on the command line.  This is a reasonable
default; without it, every retrieval would have the potential to turn
your Wget into a small version of google.

   However, visiting different hosts, or "host spanning," is sometimes
a useful option.  Maybe the images are served from a different server.
Maybe you're mirroring a site that consists of pages interlinked between
three servers.  Maybe the server has two equivalent names, and the HTML
pages refer to both interchangeably.

Span to any host--`-H'
     The `-H' option turns on host spanning, thus allowing Wget's
     recursive run to visit any host referenced by a link.  Unless
     sufficient recursion-limiting criteria are applied depth, these
     foreign hosts will typically link to yet more hosts, and so on
     until Wget ends up sucking up much more data than you have
     intended.

Limit spanning to certain domains--`-D'
     The `-D' option allows you to specify the domains that will be
     followed, thus limiting the recursion only to the hosts that
     belong to these domains.  Obviously, this makes sense only in
     conjunction with `-H'.  A typical example would be downloading the
     contents of `www.server.com', but allowing downloads from
     `images.server.com', etc.:

          wget -rH -Dserver.com http://www.server.com/

     You can specify more than one address by separating them with a
     comma, e.g. `-Ddomain1.com,domain2.com'.

Keep download off certain domains--`--exclude-domains'
     If there are domains you want to exclude specifically, you can do
     it with `--exclude-domains', which accepts the same type of
     arguments of `-D', but will _exclude_ all the listed domains.  For
     example, if you want to download all the hosts from `foo.edu'
     domain, with the exception of `sunsite.foo.edu', you can do it like
     this:

          wget -rH -Dfoo.edu --exclude-domains sunsite.foo.edu \
              http://www.foo.edu/

Types of Files
==============

   When downloading material from the web, you will often want to
restrict the retrieval to only certain file types.  For example, if you
are interested in downloading GIFs, you will not be overjoyed to get
loads of PostScript documents, and vice versa.

   Wget offers two options to deal with this problem.  Each option
description lists a short name, a long name, and the equivalent command
in `.wgetrc'.

`-A ACCLIST'
`--accept ACCLIST'
`accept = ACCLIST'
     The argument to `--accept' option is a list of file suffixes or
     patterns that Wget will download during recursive retrieval.  A
     suffix is the ending part of a file, and consists of "normal"
     letters, e.g. `gif' or `.jpg'.  A matching pattern contains
     shell-like wildcards, e.g. `books*' or `zelazny*196[0-9]*'.

     So, specifying `wget -A gif,jpg' will make Wget download only the
     files ending with `gif' or `jpg', i.e. GIFs and JPEGs.  On the
     other hand, `wget -A "zelazny*196[0-9]*"' will download only files
     beginning with `zelazny' and containing numbers from 1960 to 1969
     anywhere within.  Look up the manual of your shell for a
     description of how pattern matching works.

     Of course, any number of suffixes and patterns can be combined
     into a comma-separated list, and given as an argument to `-A'.

`-R REJLIST'
`--reject REJLIST'
`reject = REJLIST'
     The `--reject' option works the same way as `--accept', only its
     logic is the reverse; Wget will download all files _except_ the
     ones matching the suffixes (or patterns) in the list.

     So, if you want to download a whole page except for the cumbersome
     MPEGs and .AU files, you can use `wget -R mpg,mpeg,au'.
     Analogously, to download all files except the ones beginning with
     `bjork', use `wget -R "bjork*"'.  The quotes are to prevent
     expansion by the shell.

   The `-A' and `-R' options may be combined to achieve even better
fine-tuning of which files to retrieve.  E.g. `wget -A "*zelazny*" -R
.ps' will download all the files having `zelazny' as a part of their
name, but _not_ the PostScript files.

   Note that these two options do not affect the downloading of HTML
files; Wget must load all the HTMLs to know where to go at
all--recursive retrieval would make no sense otherwise.

Directory-Based Limits
======================

   Regardless of other link-following facilities, it is often useful to
place the restriction of what files to retrieve based on the directories
those files are placed in.  There can be many reasons for this--the
home pages may be organized in a reasonable directory structure; or some
directories may contain useless information, e.g. `/cgi-bin' or `/dev'
directories.

   Wget offers three different options to deal with this requirement.
Each option description lists a short name, a long name, and the
equivalent command in `.wgetrc'.

`-I LIST'
`--include LIST'
`include_directories = LIST'
     `-I' option accepts a comma-separated list of directories included
     in the retrieval.  Any other directories will simply be ignored.
     The directories are absolute paths.

     So, if you wish to download from `http://host/people/bozo/'
     following only links to bozo's colleagues in the `/people'
     directory and the bogus scripts in `/cgi-bin', you can specify:

          wget -I /people,/cgi-bin http://host/people/bozo/

`-X LIST'
`--exclude LIST'
`exclude_directories = LIST'
     `-X' option is exactly the reverse of `-I'--this is a list of
     directories _excluded_ from the download.  E.g. if you do not want
     Wget to download things from `/cgi-bin' directory, specify `-X
     /cgi-bin' on the command line.

     The same as with `-A'/`-R', these two options can be combined to
     get a better fine-tuning of downloading subdirectories.  E.g. if
     you want to load all the files from `/pub' hierarchy except for
     `/pub/worthless', specify `-I/pub -X/pub/worthless'.

`-np'
`--no-parent'
`no_parent = on'
     The simplest, and often very useful way of limiting directories is
     disallowing retrieval of the links that refer to the hierarchy
     "above" than the beginning directory, i.e. disallowing ascent to
     the parent directory/directories.

     The `--no-parent' option (short `-np') is useful in this case.
     Using it guarantees that you will never leave the existing
     hierarchy.  Supposing you issue Wget with:

          wget -r --no-parent http://somehost/~luzer/my-archive/

     You may rest assured that none of the references to
     `/~his-girls-homepage/' or `/~luzer/all-my-mpegs/' will be
     followed.  Only the archive you are interested in will be
     downloaded.  Essentially, `--no-parent' is similar to
     `-I/~luzer/my-archive', only it handles redirections in a more
     intelligent fashion.

Relative Links
==============

   When `-L' is turned on, only the relative links are ever followed.
Relative links are here defined those that do not refer to the web
server root.  For example, these links are relative:

     <a href="foo.gif">
     <a href="foo/bar.gif">
     <a href="../foo/bar.gif">

   These links are not relative:

     <a href="/foo.gif">
     <a href="/foo/bar.gif">
     <a href="http://www.server.com/foo/bar.gif">

   Using this option guarantees that recursive retrieval will not span
hosts, even without `-H'.  In simple cases it also allows downloads to
"just work" without having to convert links.

   This option is probably not very useful and might be removed in a
future release.

Following FTP Links
===================

   The rules for FTP are somewhat specific, as it is necessary for them
to be.  FTP links in HTML documents are often included for purposes of
reference, and it is often inconvenient to download them by default.

   To have FTP links followed from HTML documents, you need to specify
the `--follow-ftp' option.  Having done that, FTP links will span hosts
regardless of `-H' setting.  This is logical, as FTP links rarely point
to the same host where the HTTP server resides.  For similar reasons,
the `-L' options has no effect on such downloads.  On the other hand,
domain acceptance (`-D') and suffix rules (`-A' and `-R') apply
normally.

   Also note that followed links to FTP directories will not be
retrieved recursively further.

Time-Stamping
*************

   One of the most important aspects of mirroring information from the
Internet is updating your archives.

   Downloading the whole archive again and again, just to replace a few
changed files is expensive, both in terms of wasted bandwidth and money,
and the time to do the update.  This is why all the mirroring tools
offer the option of incremental updating.

   Such an updating mechanism means that the remote server is scanned in
search of "new" files.  Only those new files will be downloaded in the
place of the old ones.

   A file is considered new if one of these two conditions are met:

  1. A file of that name does not already exist locally.

  2. A file of that name does exist, but the remote file was modified
     more recently than the local file.

   To implement this, the program needs to be aware of the time of last
modification of both local and remote files.  We call this information
the "time-stamp" of a file.

   The time-stamping in GNU Wget is turned on using `--timestamping'
(`-N') option, or through `timestamping = on' directive in `.wgetrc'.
With this option, for each file it intends to download, Wget will check
whether a local file of the same name exists.  If it does, and the
remote file is older, Wget will not download it.

   If the local file does not exist, or the sizes of the files do not
match, Wget will download the remote file no matter what the time-stamps
say.

Time-Stamping Usage
===================

   The usage of time-stamping is simple.  Say you would like to
download a file so that it keeps its date of modification.

     wget -S http://www.gnu.ai.mit.edu/

   A simple `ls -l' shows that the time stamp on the local file equals
the state of the `Last-Modified' header, as returned by the server.  As
you can see, the time-stamping info is preserved locally, even without
`-N' (at least for HTTP).

   Several days later, you would like Wget to check if the remote file
has changed, and download it if it has.

     wget -N http://www.gnu.ai.mit.edu/

   Wget will ask the server for the last-modified date.  If the local
file has the same timestamp as the server, or a newer one, the remote
file will not be re-fetched.  However, if the remote file is more
recent, Wget will proceed to fetch it.

   The same goes for FTP.  For example:

     wget "ftp://ftp.ifi.uio.no/pub/emacs/gnus/*"

   (The quotes around that URL are to prevent the shell from trying to
interpret the `*'.)

   After download, a local directory listing will show that the
timestamps match those on the remote server.  Reissuing the command
with `-N' will make Wget re-fetch _only_ the files that have been
modified since the last download.

   If you wished to mirror the GNU archive every week, you would use a
command like the following, weekly:

     wget --timestamping -r ftp://ftp.gnu.org/pub/gnu/

   Note that time-stamping will only work for files for which the server
gives a timestamp.  For HTTP, this depends on getting a `Last-Modified'
header.  For FTP, this depends on getting a directory listing with
dates in a format that Wget can parse (see FTP Time-Stamping Internals).

HTTP Time-Stamping Internals
============================

   Time-stamping in HTTP is implemented by checking of the
`Last-Modified' header.  If you wish to retrieve the file `foo.html'
through HTTP, Wget will check whether `foo.html' exists locally.  If it
doesn't, `foo.html' will be retrieved unconditionally.

   If the file does exist locally, Wget will first check its local
time-stamp (similar to the way `ls -l' checks it), and then send a
`HEAD' request to the remote server, demanding the information on the
remote file.

   The `Last-Modified' header is examined to find which file was
modified more recently (which makes it "newer").  If the remote file is
newer, it will be downloaded; if it is older, Wget will give up.(1)

   When `--backup-converted' (`-K') is specified in conjunction with
`-N', server file `X' is compared to local file `X.orig', if extant,
rather than being compared to local file `X', which will always differ
if it's been converted by `--convert-links' (`-k').

   Arguably, HTTP time-stamping should be implemented using the
`If-Modified-Since' request.

   ---------- Footnotes ----------

   (1) As an additional check, Wget will look at the `Content-Length'
header, and compare the sizes; if they are not the same, the remote
file will be downloaded no matter what the time-stamp says.

FTP Time-Stamping Internals
===========================

   In theory, FTP time-stamping works much the same as HTTP, only FTP
has no headers--time-stamps must be ferreted out of directory listings.

   If an FTP download is recursive or uses globbing, Wget will use the
FTP `LIST' command to get a file listing for the directory containing
the desired file(s).  It will try to analyze the listing, treating it
like Unix `ls -l' output, extracting the time-stamps.  The rest is
exactly the same as for HTTP.  Note that when retrieving individual
files from an FTP server without using globbing or recursion, listing
files will not be downloaded (and thus files will not be time-stamped)
unless `-N' is specified.

   Assumption that every directory listing is a Unix-style listing may
sound extremely constraining, but in practice it is not, as many
non-Unix FTP servers use the Unixoid listing format because most (all?)
of the clients understand it.  Bear in mind that RFC959 defines no
standard way to get a file list, let alone the time-stamps.  We can
only hope that a future standard will define this.

   Another non-standard solution includes the use of `MDTM' command
that is supported by some FTP servers (including the popular
`wu-ftpd'), which returns the exact time of the specified file.  Wget
may support this command in the future.

Startup File
************

   Once you know how to change default settings of Wget through command
line arguments, you may wish to make some of those settings permanent.
You can do that in a convenient way by creating the Wget startup
file--`.wgetrc'.

   Besides `.wgetrc' is the "main" initialization file, it is
convenient to have a special facility for storing passwords.  Thus Wget
reads and interprets the contents of `$HOME/.netrc', if it finds it.
You can find `.netrc' format in your system manuals.

   Wget reads `.wgetrc' upon startup, recognizing a limited set of
commands.

Wgetrc Location
===============

   When initializing, Wget will look for a "global" startup file,
`/usr/local/etc/wgetrc' by default (or some prefix other than
`/usr/local', if Wget was not installed there) and read commands from
there, if it exists.

   Then it will look for the user's file.  If the environmental variable
`WGETRC' is set, Wget will try to load that file.  Failing that, no
further attempts will be made.

   If `WGETRC' is not set, Wget will try to load `$HOME/.wgetrc'.

   The fact that user's settings are loaded after the system-wide ones
means that in case of collision user's wgetrc _overrides_ the
system-wide wgetrc (in `/usr/local/etc/wgetrc' by default).  Fascist
admins, away!

Wgetrc Syntax
=============

   The syntax of a wgetrc command is simple:

     variable = value

   The "variable" will also be called "command".  Valid "values" are
different for different commands.

   The commands are case-insensitive and underscore-insensitive.  Thus
`DIr__PrefiX' is the same as `dirprefix'.  Empty lines, lines beginning
with `#' and lines containing white-space only are discarded.

   Commands that expect a comma-separated list will clear the list on an
empty command.  So, if you wish to reset the rejection list specified in
global `wgetrc', you can do it with:

     reject =

Wgetrc Commands
===============

   The complete set of commands is listed below.  Legal values are
listed after the `='.  Simple Boolean values can be set or unset using
`on' and `off' or `1' and `0'.  A fancier kind of Boolean allowed in
some cases is the "lockable Boolean", which may be set to `on', `off',
`always', or `never'.  If an option is set to `always' or `never', that
value will be locked in for the duration of the Wget
invocation--commandline options will not override.

   Some commands take pseudo-arbitrary values.  ADDRESS values can be
hostnames or dotted-quad IP addresses.  N can be any positive integer,
or `inf' for infinity, where appropriate.  STRING values can be any
non-empty string.

   Most of these commands have commandline equivalents (see
Invoking), though some of the more obscure or rarely used ones do not.

accept/reject = STRING
     Same as `-A'/`-R' (see Types of Files).

add_hostdir = on/off
     Enable/disable host-prefixed file names.  `-nH' disables it.

continue = on/off
     If set to on, force continuation of preexistent partially retrieved
     files.  See `-c' before setting it.

background = on/off
     Enable/disable going to background--the same as `-b' (which
     enables it).

backup_converted = on/off
     Enable/disable saving pre-converted files with the suffix
     `.orig'--the same as `-K' (which enables it).

base = STRING
     Consider relative URLs in URL input files forced to be interpreted
     as HTML as being relative to STRING--the same as `-B'.

bind_address = ADDRESS
     Bind to ADDRESS, like the `--bind-address' option.

cache = on/off
     When set to off, disallow server-caching.  See the `-C' option.

convert links = on/off
     Convert non-relative links locally.  The same as `-k'.

cookies = on/off
     When set to off, disallow cookies.  See the `--cookies' option.

load_cookies = FILE
     Load cookies from FILE.  See `--load-cookies'.

save_cookies = FILE
     Save cookies to FILE.  See `--save-cookies'.

cut_dirs = N
     Ignore N remote directory components.

debug = on/off
     Debug mode, same as `-d'.

delete_after = on/off
     Delete after download--the same as `--delete-after'.

dir_prefix = STRING
     Top of directory tree--the same as `-P'.

dirstruct = on/off
     Turning dirstruct on or off--the same as `-x' or `-nd',
     respectively.

domains = STRING
     Same as `-D' (see Spanning Hosts).

dot_bytes = N
     Specify the number of bytes "contained" in a dot, as seen
     throughout the retrieval (1024 by default).  You can postfix the
     value with `k' or `m', representing kilobytes and megabytes,
     respectively.  With dot settings you can tailor the dot retrieval
     to suit your needs, or you can use the predefined "styles" (see
     Download Options).

dots_in_line = N
     Specify the number of dots that will be printed in each line
     throughout the retrieval (50 by default).

dot_spacing = N
     Specify the number of dots in a single cluster (10 by default).

exclude_directories = STRING
     Specify a comma-separated list of directories you wish to exclude
     from download--the same as `-X' (see Directory-Based Limits).

exclude_domains = STRING
     Same as `--exclude-domains' (see Spanning Hosts).

follow_ftp = on/off
     Follow FTP links from HTML documents--the same as `--follow-ftp'.

follow_tags = STRING
     Only follow certain HTML tags when doing a recursive retrieval,
     just like `--follow-tags'.

force_html = on/off
     If set to on, force the input filename to be regarded as an HTML
     document--the same as `-F'.

ftp_proxy = STRING
     Use STRING as FTP proxy, instead of the one specified in
     environment.

glob = on/off
     Turn globbing on/off--the same as `-g'.

header = STRING
     Define an additional header, like `--header'.

html_extension = on/off
     Add a `.html' extension to `text/html' files without it, like `-E'.

http_passwd = STRING
     Set HTTP password.

http_proxy = STRING
     Use STRING as HTTP proxy, instead of the one specified in
     environment.

http_user = STRING
     Set HTTP user to STRING.

ignore_length = on/off
     When set to on, ignore `Content-Length' header; the same as
     `--ignore-length'.

ignore_tags = STRING
     Ignore certain HTML tags when doing a recursive retrieval, just
     like `-G' / `--ignore-tags'.

include_directories = STRING
     Specify a comma-separated list of directories you wish to follow
     when downloading--the same as `-I'.

input = STRING
     Read the URLs from STRING, like `-i'.

kill_longer = on/off
     Consider data longer than specified in content-length header as
     invalid (and retry getting it).  The default behaviour is to save
     as much data as there is, provided there is more than or equal to
     the value in `Content-Length'.

limit_rate = RATE
     Limit the download speed to no more than RATE bytes per second.
     The same as `--limit-rate'.

logfile = STRING
     Set logfile--the same as `-o'.

login = STRING
     Your user name on the remote machine, for FTP.  Defaults to
     `anonymous'.

mirror = on/off
     Turn mirroring on/off.  The same as `-m'.

netrc = on/off
     Turn reading netrc on or off.

noclobber = on/off
     Same as `-nc'.

no_parent = on/off
     Disallow retrieving outside the directory hierarchy, like
     `--no-parent' (see Directory-Based Limits).

no_proxy = STRING
     Use STRING as the comma-separated list of domains to avoid in
     proxy loading, instead of the one specified in environment.

output_document = STRING
     Set the output filename--the same as `-O'.

page_requisites = on/off
     Download all ancillary documents necessary for a single HTML page
     to display properly--the same as `-p'.

passive_ftp = on/off/always/never
     Set passive FTP--the same as `--passive-ftp'.  Some scripts and
     `.pm' (Perl module) files download files using `wget
     --passive-ftp'.  If your firewall does not allow this, you can set
     `passive_ftp = never' to override the commandline.

passwd = STRING
     Set your FTP password to PASSWORD.  Without this setting, the
     password defaults to `username@hostname.domainname'.

progress = STRING
     Set the type of the progress indicator.  Legal types are "dot" and
     "bar".

proxy_user = STRING
     Set proxy authentication user name to STRING, like `--proxy-user'.

proxy_passwd = STRING
     Set proxy authentication password to STRING, like `--proxy-passwd'.

referer = STRING
     Set HTTP `Referer:' header just like `--referer'.  (Note it was
     the folks who wrote the HTTP spec who got the spelling of
     "referrer" wrong.)

quiet = on/off
     Quiet mode--the same as `-q'.

quota = QUOTA
     Specify the download quota, which is useful to put in the global
     `wgetrc'.  When download quota is specified, Wget will stop
     retrieving after the download sum has become greater than quota.
     The quota can be specified in bytes (default), kbytes `k'
     appended) or mbytes (`m' appended).  Thus `quota = 5m' will set
     the quota to 5 mbytes.  Note that the user's startup file
     overrides system settings.

reclevel = N
     Recursion level--the same as `-l'.

recursive = on/off
     Recursive on/off--the same as `-r'.

relative_only = on/off
     Follow only relative links--the same as `-L' (see Relative Links).

remove_listing = on/off
     If set to on, remove FTP listings downloaded by Wget.  Setting it
     to off is the same as `-nr'.

retr_symlinks = on/off
     When set to on, retrieve symbolic links as if they were plain
     files; the same as `--retr-symlinks'.

robots = on/off
     Specify whether the norobots convention is respected by Wget, "on"
     by default.  This switch controls both the `/robots.txt' and the
     `nofollow' aspect of the spec.  See Robot Exclusion, for more
     details about this.  Be sure you know what you are doing before
     turning this off.

server_response = on/off
     Choose whether or not to print the HTTP and FTP server
     responses--the same as `-S'.

span_hosts = on/off
     Same as `-H'.

timeout = N
     Set timeout value--the same as `-T'.

timestamping = on/off
     Turn timestamping on/off.  The same as `-N' (see
     Time-Stamping).

tries = N
     Set number of retries per URL--the same as `-t'.

use_proxy = on/off
     Turn proxy support on/off.  The same as `-Y'.

verbose = on/off
     Turn verbose on/off--the same as `-v'/`-nv'.

wait = N
     Wait N seconds between retrievals--the same as `-w'.

waitretry = N
     Wait up to N seconds between retries of failed retrievals
     only--the same as `--waitretry'.  Note that this is turned on by
     default in the global `wgetrc'.

randomwait = on/off
     Turn random between-request wait times on or off. The same as
     `--random-wait'.

Sample Wgetrc
=============

   This is the sample initialization file, as given in the distribution.
It is divided in two section--one for global usage (suitable for global
startup file), and one for local usage (suitable for `$HOME/.wgetrc').
Be careful about the things you change.

   Note that almost all the lines are commented out.  For a command to
have any effect, you must remove the `#' character at the beginning of
its line.

     ###
     ### Sample Wget initialization file .wgetrc
     ###

     ## You can use this file to change the default behaviour of wget or to
     ## avoid having to type many many command-line options. This file does
     ## not contain a comprehensive list of commands -- look at the manual
     ## to find out what you can put into this file.
     ##
     ## Wget initialization file can reside in /usr/local/etc/wgetrc
     ## (global, for all users) or $HOME/.wgetrc (for a single user).
     ##
     ## To use the settings in this file, you will have to uncomment them,
     ## as well as change them, in most cases, as the values on the
     ## commented-out lines are the default values (e.g. "off").

     ##
     ## Global settings (useful for setting up in /usr/local/etc/wgetrc).
     ## Think well before you change them, since they may reduce wget's
     ## functionality, and make it behave contrary to the documentation:
     ##

     # You can set retrieve quota for beginners by specifying a value
     # optionally followed by 'K' (kilobytes) or 'M' (megabytes).  The
     # default quota is unlimited.
     #quota = inf

     # You can lower (or raise) the default number of retries when
     # downloading a file (default is 20).
     #tries = 20

     # Lowering the maximum depth of the recursive retrieval is handy to
     # prevent newbies from going too "deep" when they unwittingly start
     # the recursive retrieval.  The default is 5.
     #reclevel = 5

     # Many sites are behind firewalls that do not allow initiation of
     # connections from the outside.  On these sites you have to use the
     # `passive' feature of FTP.  If you are behind such a firewall, you
     # can turn this on to make Wget use passive FTP by default.
     #passive_ftp = off

     # The "wait" command below makes Wget wait between every connection.
     # If, instead, you want Wget to wait only between retries of failed
     # downloads, set waitretry to maximum number of seconds to wait (Wget
     # will use "linear backoff", waiting 1 second after the first failure
     # on a file, 2 seconds after the second failure, etc. up to this max).
     waitretry = 10

     ##
     ## Local settings (for a user to set in his $HOME/.wgetrc).  It is
     ## *highly* undesirable to put these settings in the global file, since
     ## they are potentially dangerous to "normal" users.
     ##
     ## Even when setting up your own ~/.wgetrc, you should know what you
     ## are doing before doing so.
     ##

     # Set this to on to use timestamping by default:
     #timestamping = off

     # It is a good idea to make Wget send your email address in a `From:'
     # header with your request (so that server administrators can contact
     # you in case of errors).  Wget does *not* send `From:' by default.
     #header = From: Your Name <username@site.domain>

     # You can set up other headers, like Accept-Language.  Accept-Language
     # is *not* sent by default.
     #header = Accept-Language: en

     # You can set the default proxies for Wget to use for http and ftp.
     # They will override the value in the environment.
     #http_proxy = http://proxy.yoyodyne.com:18023/
     #ftp_proxy = http://proxy.yoyodyne.com:18023/

     # If you do not want to use proxy at all, set this to off.
     #use_proxy = on

     # You can customize the retrieval outlook.  Valid options are default,
     # binary, mega and micro.
     #dot_style = default

     # Setting this to off makes Wget not download /robots.txt.  Be sure to
     # know *exactly* what /robots.txt is and how it is used before changing
     # the default!
     #robots = on

     # It can be useful to make Wget wait between connections.  Set this to
     # the number of seconds you want Wget to wait.
     #wait = 0

     # You can force creating directory structure, even if a single is being
     # retrieved, by setting this to on.
     #dirstruct = off

     # You can turn on recursive retrieving by default (don't do this if
     # you are not sure you know what it means) by setting this to on.
     #recursive = off

     # To always back up file X as X.orig before converting its links (due
     # to -k / --convert-links / convert_links = on having been specified),
     # set this variable to on:
     #backup_converted = off

     # To have Wget follow FTP links from HTML files by default, set this
     # to on:
     #follow_ftp = off

Examples
********

   The examples are divided into three sections loosely based on their
complexity.

Simple Usage
============

   * Say you want to download a URL.  Just type:

          wget http://fly.srk.fer.hr/

   * But what will happen if the connection is slow, and the file is
     lengthy?  The connection will probably fail before the whole file
     is retrieved, more than once.  In this case, Wget will try getting
     the file until it either gets the whole of it, or exceeds the
     default number of retries (this being 20).  It is easy to change
     the number of tries to 45, to insure that the whole file will
     arrive safely:

          wget --tries=45 http://fly.srk.fer.hr/jpg/flyweb.jpg

   * Now let's leave Wget to work in the background, and write its
     progress to log file `log'.  It is tiring to type `--tries', so we
     shall use `-t'.

          wget -t 45 -o log http://fly.srk.fer.hr/jpg/flyweb.jpg &

     The ampersand at the end of the line makes sure that Wget works in
     the background.  To unlimit the number of retries, use `-t inf'.

   * The usage of FTP is as simple.  Wget will take care of login and
     password.

          wget ftp://gnjilux.srk.fer.hr/welcome.msg

   * If you specify a directory, Wget will retrieve the directory
     listing, parse it and convert it to HTML.  Try:

          wget ftp://prep.ai.mit.edu/pub/gnu/
          links index.html

Advanced Usage
==============

   * You have a file that contains the URLs you want to download?  Use
     the `-i' switch:

          wget -i FILE

     If you specify `-' as file name, the URLs will be read from
     standard input.

   * Create a five levels deep mirror image of the GNU web site, with
     the same directory structure the original has, with only one try
     per document, saving the log of the activities to `gnulog':

          wget -r http://www.gnu.org/ -o gnulog

   * The same as the above, but convert the links in the HTML files to
     point to local files, so you can view the documents off-line:

          wget --convert-links -r http://www.gnu.org/ -o gnulog

   * Retrieve only one HTML page, but make sure that all the elements
     needed for the page to be displayed, such as inline images and
     external style sheets, are also downloaded.  Also make sure the
     downloaded page references the downloaded links.

          wget -p --convert-links http://www.server.com/dir/page.html

     The HTML page will be saved to `www.server.com/dir/page.html', and
     the images, stylesheets, etc., somewhere under `www.server.com/',
     depending on where they were on the remote server.

   * The same as the above, but without the `www.server.com/' directory.
     In fact, I don't want to have all those random server directories
     anyway--just save _all_ those files under a `download/'
     subdirectory of the current directory.

          wget -p --convert-links -nH -nd -Pdownload \
               http://www.server.com/dir/page.html

   * Retrieve the index.html of `www.lycos.com', showing the original
     server headers:

          wget -S http://www.lycos.com/

   * Save the server headers with the file, perhaps for post-processing.

          wget -s http://www.lycos.com/
          more index.html

   * Retrieve the first two levels of `wuarchive.wustl.edu', saving them
     to `/tmp'.

          wget -r -l2 -P/tmp ftp://wuarchive.wustl.edu/

   * You want to download all the GIFs from a directory on an HTTP
     server.  You tried `wget http://www.server.com/dir/*.gif', but that
     didn't work because HTTP retrieval does not support globbing.  In
     that case, use:

          wget -r -l1 --no-parent -A.gif http://www.server.com/dir/

     More verbose, but the effect is the same.  `-r -l1' means to
     retrieve recursively (see Recursive Retrieval), with maximum
     depth of 1.  `--no-parent' means that references to the parent
     directory are ignored (see Directory-Based Limits), and
     `-A.gif' means to download only the GIF files.  `-A "*.gif"' would
     have worked too.

   * Suppose you were in the middle of downloading, when Wget was
     interrupted.  Now you do not want to clobber the files already
     present.  It would be:

          wget -nc -r http://www.gnu.org/

   * If you want to encode your own username and password to HTTP or
     FTP, use the appropriate URL syntax (see URL Format).

          wget ftp://hniksic:mypassword@unix.server.com/.emacs

     Note, however, that this usage is not advisable on multi-user
     systems because it reveals your password to anyone who looks at
     the output of `ps'.

   * You would like the output documents to go to standard output
     instead of to files?

          wget -O - http://jagor.srce.hr/ http://www.srce.hr/

     You can also combine the two options and make pipelines to
     retrieve the documents from remote hotlists:

          wget -O - http://cool.list.com/ | wget --force-html -i -

Very Advanced Usage
===================

   * If you wish Wget to keep a mirror of a page (or FTP
     subdirectories), use `--mirror' (`-m'), which is the shorthand for
     `-r -l inf -N'.  You can put Wget in the crontab file asking it to
     recheck a site each Sunday:

          crontab
          0 0 * * 0 wget --mirror http://www.gnu.org/ -o /home/me/weeklog

   * In addition to the above, you want the links to be converted for
     local viewing.  But, after having read this manual, you know that
     link conversion doesn't play well with timestamping, so you also
     want Wget to back up the original HTML files before the
     conversion.  Wget invocation would look like this:

          wget --mirror --convert-links --backup-converted  \
               http://www.gnu.org/ -o /home/me/weeklog

   * But you've also noticed that local viewing doesn't work all that
     well when HTML files are saved under extensions other than `.html',
     perhaps because they were served as `index.cgi'.  So you'd like
     Wget to rename all the files served with content-type `text/html'
     to `NAME.html'.

          wget --mirror --convert-links --backup-converted \
               --html-extension -o /home/me/weeklog        \
               http://www.gnu.org/

     Or, with less typing:

          wget -m -k -K -E http://www.gnu.org/ -o /home/me/weeklog

Various
*******

   This chapter contains all the stuff that could not fit anywhere else.

Proxies
=======

   "Proxies" are special-purpose HTTP servers designed to transfer data
from remote servers to local clients.  One typical use of proxies is
lightening network load for users behind a slow connection.  This is
achieved by channeling all HTTP and FTP requests through the proxy
which caches the transferred data.  When a cached resource is requested
again, proxy will return the data from cache.  Another use for proxies
is for companies that separate (for security reasons) their internal
networks from the rest of Internet.  In order to obtain information
from the Web, their users connect and retrieve remote data using an
authorized proxy.

   Wget supports proxies for both HTTP and FTP retrievals.  The
standard way to specify proxy location, which Wget recognizes, is using
the following environment variables:

`http_proxy'
     This variable should contain the URL of the proxy for HTTP
     connections.

`ftp_proxy'
     This variable should contain the URL of the proxy for FTP
     connections.  It is quite common that HTTP_PROXY and FTP_PROXY are
     set to the same URL.

`no_proxy'
     This variable should contain a comma-separated list of domain
     extensions proxy should _not_ be used for.  For instance, if the
     value of `no_proxy' is `.mit.edu', proxy will not be used to
     retrieve documents from MIT.

   In addition to the environment variables, proxy location and settings
may be specified from within Wget itself.

`-Y on/off'
`--proxy=on/off'
`proxy = on/off'
     This option may be used to turn the proxy support on or off.  Proxy
     support is on by default, provided that the appropriate environment
     variables are set.

`http_proxy = URL'
`ftp_proxy = URL'
`no_proxy = STRING'
     These startup file variables allow you to override the proxy
     settings specified by the environment.

   Some proxy servers require authorization to enable you to use them.
The authorization consists of "username" and "password", which must be
sent by Wget.  As with HTTP authorization, several authentication
schemes exist.  For proxy authorization only the `Basic' authentication
scheme is currently implemented.

   You may specify your username and password either through the proxy
URL or through the command-line options.  Assuming that the company's
proxy is located at `proxy.company.com' at port 8001, a proxy URL
location containing authorization data might look like this:

     http://hniksic:mypassword@proxy.company.com:8001/

   Alternatively, you may use the `proxy-user' and `proxy-password'
options, and the equivalent `.wgetrc' settings `proxy_user' and
`proxy_passwd' to set the proxy username and password.

Distribution
============

   Like all GNU utilities, the latest version of Wget can be found at
the master GNU archive site prep.ai.mit.edu, and its mirrors.  For
example, Wget 1.8.2 can be found at
<ftp://prep.ai.mit.edu/gnu/wget/wget-1.8.2.tar.gz>

Mailing List
============

   Wget has its own mailing list at <wget@sunsite.dk>, thanks to
Karsten Thygesen.  The mailing list is for discussion of Wget features
and web, reporting Wget bugs (those that you think may be of interest
to the public) and mailing announcements.  You are welcome to
subscribe.  The more people on the list, the better!

   To subscribe, send mail to <wget-subscribe@sunsite.dk>.  the magic
word `subscribe' in the subject line.  Unsubscribe by mailing to
<wget-unsubscribe@sunsite.dk>.

   The mailing list is archived at <http://fly.srk.fer.hr/archive/wget>.
Alternative archive is available at
<http://www.mail-archive.com/wget%40sunsite.auc.dk/>.

Reporting Bugs
==============

   You are welcome to send bug reports about GNU Wget to
<bug-wget@gnu.org>.

   Before actually submitting a bug report, please try to follow a few
simple guidelines.

  1. Please try to ascertain that the behaviour you see really is a
     bug.  If Wget crashes, it's a bug.  If Wget does not behave as
     documented, it's a bug.  If things work strange, but you are not
     sure about the way they are supposed to work, it might well be a
     bug.

  2. Try to repeat the bug in as simple circumstances as possible.
     E.g. if Wget crashes while downloading `wget -rl0 -kKE -t5 -Y0
     http://yoyodyne.com -o /tmp/log', you should try to see if the
     crash is repeatable, and if will occur with a simpler set of
     options.  You might even try to start the download at the page
     where the crash occurred to see if that page somehow triggered the
     crash.

     Also, while I will probably be interested to know the contents of
     your `.wgetrc' file, just dumping it into the debug message is
     probably a bad idea.  Instead, you should first try to see if the
     bug repeats with `.wgetrc' moved out of the way.  Only if it turns
     out that `.wgetrc' settings affect the bug, mail me the relevant
     parts of the file.

  3. Please start Wget with `-d' option and send the log (or the
     relevant parts of it).  If Wget was compiled without debug support,
     recompile it.  It is _much_ easier to trace bugs with debug support
     on.

  4. If Wget has crashed, try to run it in a debugger, e.g. `gdb `which
     wget` core' and type `where' to get the backtrace.